

<template>
    <v-row class="fill-height">
        <v-col class="py-0 my-0" cols="12">
            <SystemBar
                :calendarTitle="calendarTitle"
                :stepType="state.stepType"
                @setToday="setToday"
                @prev="state.changeRange(-1)"
                @next="state.changeRange(+1)"
                @onChangeType="state.onChangeType"
            />
        </v-col>
        <v-col cols="12">
          <v-card elevation="4">
              <v-card-text>
                <v-calendar
                    v-if="state.range !== undefined"
                    ref="calendar"
                    v-model="focus"
                    color="primary"
                    event-text-color="#5f5f5f"
                    :events="state.receiptSummaries"
                    :event-color="getEventColor"
                    :start="state.range.start"
                    :type="state.stepType"
                    @click:event="showEvent"
                    @click:more="viewDay"
                    @click:date="viewDay"
                />
              </v-card-text>
          </v-card>
      </v-col>
  </v-row>

</template>

<script lang="ts">
import { Component, Inject, Prop, Vue, Watch } from 'vue-property-decorator'
// import Header from "@/components/Header.vue"
import { Observer } from "mobx-vue";
import { CalendarModel } from "@/store/modules/calendar";
import Overview from "@/views/Overview.vue";
import SystemBar from "@/components/SystemBar.vue";
import Share from "@/views/Share.vue";
import { CalendarDate } from "@/types/calendar"
import { generateRange, getTimestamp } from "@/utils/date"

@Observer
@Component({ components: { Overview, Share, SystemBar }})
export default class Calendar extends Vue {
    private focus: string = ''
    private selectedEvent: object = {}
    private selectedElement: object = {}
    private selectedOpen: boolean = false
    @Inject("calendarModel") state!: CalendarModel
    private dialog: boolean = false
    @Prop() displayedDate !: string
    @Prop({ default: false }) edited !: boolean

    get initialized() {
        return this.state.root.ipfs.initialized;
    }

    @Watch("initialized")
    onInitialized(newVal: boolean) {
        if (newVal) this.state.initializeRange();
    }

    private get calendarTitle() {
        const calendarInstance = this.calendarInstance();
        return calendarInstance ? calendarInstance.title : this.$t("calendar.householdExpenses");
    }

    private calendarInstance (): Vue & { value: string, lastStart: CalendarDate, lastEnd: CalendarDate, title: string, getNow: () => CalendarDate, checkChange: () => void, prev: () => void, next: () => void, getFormatter: () => any } {
      return this.$refs.calendar as Vue & { value: string, lastStart: CalendarDate, lastEnd: CalendarDate, title: string, getNow: () => CalendarDate, checkChange: () => void, prev: () => void, next: () => void, getFormatter: () => any };
    }

    private mounted() {
        if (this.state.range !== undefined && !this.edited) {
            return;
        }
        // const calendarInstance = this.calendarInstance();
        // if (calendarInstance !== undefined)
        //     calendarInstance.checkChange();
        if (this.displayedDate === undefined) {
            this.state.setRange(
                generateRange(getTimestamp(), 0, this.state.stepType));
        } else {
            this.state.setRange(
                generateRange(getTimestamp(this.displayedDate), 0, this.state.stepType));
        }
    }
    private getEventColor(event: any) {
        return event.color
    }
    private viewDay(params: any) {
      const { date } = params;
      this.$router.push({
          name: "day",
          params: {
              day: date
          }
      }).catch(err => {
          console.log('Redirected twice? ', err)
      });
    }
    private setToday () {
        this.focus = ''
    }

    private setRange() {
        const calendarInstance = this.calendarInstance();
        this.state.setRange(
            generateRange(
                getTimestamp(calendarInstance.lastStart.date), 0, this.state.stepType));
    }
    // private prev () {
    //     const calendarInstance = this.calendarInstance()
    //     calendarInstance.prev();
    // }
    // private next () {
    //     const calendarInstance = this.calendarInstance()
    //     calendarInstance.next();
    // }
    private showEvent(params: any) {
      const { nativeEvent, event } = params;
        const open = () => {
            this.selectedEvent = event
            this.selectedElement = nativeEvent.target
            setTimeout(() => {
                this.selectedOpen = true
            }, 10)
        }

        if (this.selectedOpen) {
            this.selectedOpen = false
            setTimeout(open, 10)
        } else {
            open()
        }

        nativeEvent.stopPropagation()
    }

    // private async loadReceipts(start: string, end: string) {
      // await this.state.fetchReceipts(new Date(start).getTime(), new Date(end).getTime());
        // const ok = await this.state.fetchReceipts(new Date(start.date).getTime(), new Date(end.date).getTime());
        // if (!ok) this.$router.push({ name: "login" });
    // }
}

</script>
